from abc import ABC, abstractmethod

import discord


class PermissionServiceABC(ABC):
    @abstractmethod
    def __init__(self):
        pass

    @abstractmethod
    def get_admins(self, g_id: int) -> list[discord.Member]:
        pass

    @abstractmethod
    def get_moderators(self, g_id: int) -> list[discord.Member]:
        pass

    @abstractmethod
    def is_member_admin(self, member: discord.Member) -> bool:
        pass

    @abstractmethod
    def is_member_moderator(self, member: discord.Member) -> bool:
        pass

    @abstractmethod
    def is_member_technician(self, member: discord.Member) -> bool:
        pass
